# Contributing | Etc2Comp

Thank you for contributing to the Etc2Comp community!

 - [Have a usage question?](#question)
 - [Think you found a bug?](#issue)
 - [Have a feature request?](#feature)
 - [Want to submit a pull request?](#submit)
 - [Small print](#smallprint)

## <a name="question"></a> Have a usage question?

 - Review the README.md to make sure you're building the binary correctly.
 - Execute the binary with -h to show the usage help.
 - Search through [old issues](https://github.com/google/etc2comp/issues)
 for an answer to your question.
 - If you still haven't found an answer to your question, [open a new issue](https://github.com/google/etc2comp/issues/new).
Please use the provided bug report template and include a minimal repro.

## <a name="issue"></a> Think you found a bug?

The library is experimental so that's highly likely. Follow the same
procedure above for questions. If you are up to the challenge,
[submit a Pull Request](#submit) with a fix!

## <a name="feature"></a> Have a feature request?

Great! Make sure the feature request isn't already listed in 
[existing issues](https://github.com/google/etc2comp/issues),
then go ahead and [open a new issue](https://github.com/google/etc2comp/issues/new).
Remove the default template information and specify what you are requesting
technically, as well as, specifying what use cases it supports.

## <a name="submit"></a> Want to submit a pull request?

Sweet, we'd love to accept your contribution! [Open a new pull request](https://github.com/google/etc2comp/compare).

If you want to implement a new feature, please open an issue with a
proposal first to discuss the change.

You will need to sign our [Contributor License Agreement](https://cla.developers.google.com/about/google-individual)
before we can accept your pull request.

## <a name="smallprint"></a> The small print
Contributions made by corporations are covered by a different
agreement than the one above, the
[Software Grant and Corporate Contributor License Agreement]
(https://cla.developers.google.com/about/google-corporate).